Description

Reported by Alvaro Cafiete Amorés on gvsig_usuarios list:

"Hola a todos: al exportar un mapa a pdf en gvsig 2.1 final ( y también me ocurria en las versiones de desarrollo), el trazado de lineas
que tienen una longitud alrededor de un metro aparecen zigzagueantes. Esto mismo no me ocurria con la version 1.12 o apenas es
imperceptible. Es la salida a pdf la que me da problemas. En cambio la salida ps aparecen correctamente trazadas. Igualmente
aparece bien la impresién del mapa directamente en la impresora. (también he probado a imprimir el fichero pdf y Iégicamente lo que
se ve en pantalla es lo que se imprime, es decir, lineas quebradas o en zig-zag). Si las lineas son horizontales o verticales el trazado
en pdf es correcto. Asi por ejemplo si tenemos una curva de un camino y esta dibujada por polilineas con segmentos de linea de
alrededor de un metro, el trazado en pdf aparece como he descrito de modo que llegan a cruzarse entre si las lineas de ambas orillas
del camino.

No sé si abrir otro hilo pero otro error que sucede y por si tuviera el mismo origen, es que la cuadricula no aparece en el lugar que
debiera, me explico: he adjuntado dos ficheros pdf, uno creado con gvsig1.12 y otro con gvsig2.1 para que podais observar como las
lineas diagonales aparecen quebradas en la versién 2.1.

He adjuntado ademas un fichero comprimido zip con los tres ficheros shape del dibujo para que intentéis reproducir el error, a ver si
es que solo me sucede a mi.

El shape como podéis ver es un cuadrado y una linea diagonal, tiene una longitud de 100 metros pero esta formado por segmentos
de un metro de longitud. Los otros dos cuadrados son una copia del primero pero les he dado una escala de 2 y 5 de modo que
mediran doscientos metros y quinientos pero los segmentos seran de 2 y 5 metros respectivamente.

Respecto a la cuadricula, fijaos que el cuadrado de 100x100 (el de la izquierda) tiene su origen en el punto (0,0) y viene fielmente
representado en el mapa generado con gvsig1.12 pero incorrectamente en la version 2.1.

La impresion esta a escala 1:5000, si la hubiera hecho a escala inferior 1:1000 el error se minimiza. También he intentado cambiar el
grosor de la linea, pixeles, metros, etc. y no se corrige.

Muchas gracias a todos."

See attachments.

History

#1 - 02/15/2015 08:59 PM - Cesar Martinez Izquierdo
- File zigzag1_12_5000.pdf added

- File zigzag2 1_5000.pdf added

- File ZIGZAG.zip added

#2 - 04/24/2015 12:26 PM - Cesar Martinez lzquierdo
- Status changed from New to In progress
#3 - 04/24/2015 08:36 PM - Cesar Martinez lzquierdo
- Category deleted (Document layout)

This is not a printing-specific problem: the same effect can be seen on the View document.

| have done several tests but | have not been able to solve it for the moment, but | see some potential sources of this defect:

- getShapeType() method in org.gvsig.fmap.geom.generalpath.primitive.curve.line.Line2D returns TYPES.CURVE. Should it return TYPES.LINE??
- the geometries are being printed using the DrawlInts operation. Should we use plain Draw instead?

- the Drawlnts operation truncates the coordinates from double to int (e.g. antX = (int) ptDst.getX()). Probably we should use round to get more
accurate results (e.g. antX = (int) Math.round(ptDst.getX())).

#4 - 04/24/2015 09:42 PM - Cesar Martinez lzquierdo

I've tried using Draw operation instead of Drawlnts, but it gets eventually rounded to integers anyway so the problem still happens.

Draw operation calls to geom.getShape(affineTransform), which creates a DrawGeometryShape which finally creates a DrawGeneralPathXlterator to

simplify the general path for drawing.

I've tried modifying DrawGeneralPathXlterator to produce float points instead of integers and then the error does not happen any more (the lines are
correctly visualized in the PDF).

The question is whether this change on DrawGeneralPathXIterator behaviour could be valid for all the scenarios or we need to create a different
strategy for printing (such as creating a Print operation which overrides the default pathlterator).

#5 - 04/24/2015 10:14 PM - Cesar Martinez lzquierdo

Seguramente en la vista (en pantalla) es inevitable porque es un efecto del redondeo de double a int, pero para exportacion a PDF se puede evitar
este defecto ya que permite coordenadas en float (he hecho una prueba de concepto que funciona).

El caso es cémo implementarlo limpiamente en el core. Por lo que he visto, se acaba llamando al método print de la simbologia (en este caso
SimpleLineSymbol), que a su vez llama a la operacién Drawlnts.

Se me ocurre que para impresion deberia usarse la operacion Draw, que si su nombre no engana no deberia redondear a enteros. Sin embargo, Draw
también redondea a enteros, ya que acaba llamando a
g.draw(geomToDraw.getShape(affineTransform));

que a su vez acaba creando un DrawGeometryShape y un DrawGeneralPathXlterator, y este ultimo redondea a enteros.

Una solucién seria que el método Draw crease un wrapper de la geometria de forma que su método getShape use un path iterator que no redondee a
enteros. Otra opcién seria cambiar el comportamiento general de DrawGeneralPathXlterator para que no redondease a enteros. Segin me ha
parecido entedner, para dibujado en pantalla se usa DrawlInts que usa su propio path iterator y por tanto no le afectaria.

Otra opcién es crear una nueva operacion Print e implementar alli las soluciones que he comentado para Draw. Esto tendria bastante sentido porque
Draw acaba llamando a doc.getSymbol().draw, cuando existe doc.getSymbol().print que seria lo correcto (aunque esto no nos evitaria implementar las
soluciones que he comentado antes).

#6 - 05/04/2015 09:47 AM - Cesar Martinez Izquierdo

Hola, creo que este mensaje de Ruth Esteban en la lista respecto a la calidad de la impresion puede ser un sintoma del mencionado problema del
redondeo a enteros:
- 'Y lo mas importante porque no se puede exportar el mapa en formato imagen,
solo en PDF, siempre tengo problemas, o las lineas creadas no tienen el
grosor que yo le he dado en los mapas, o la leyenda no esta para nada bien,

o pierde demasiada calidad cuando lo exportas a PDF, y mas si luego quieres
incluirlo a un documento, ya pierdes toda la calidad, y yo necesito imagenes

de muy buena calidad. Asi que al final acabo haciendo mapas locales y
caseros a mano, con las imagenes exportadas de la vista, lo que es un gran

fastidio"

#7 - 04/10/2020 02:16 PM - Alvaro Anguix

- Status changed from In progress to New

#8 - 04/13/2020 09:31 AM - Alvaro Anguix

- Category set to Document layout

#9 - 04/27/2020 08:38 AM - Alvaro Anguix

- Status changed from New to Closed

En la 2.5.1 se imprime correctamente y no aparece ninguno de los 2 problemas indicados; ni el desplazamiento ni las diagonales con distorsiones.

Files

ZIGZAG.zip 9.2 KB 02/15/2015 Cesar Martinez Izquierdo
zigzag2_1_5000.pdf 42.1 KB 02/15/2015 Cesar Martinez Izquierdo
zigzag1_12_5000.pdf 108 KB 02/15/2015 Cesar Martinez Izquierdo
